<HTML>
<HEAD>

<!--comment -->

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<TITLE>Sample putData meta macros</TITLE>

<META name="description" content="Description of the PutData User Commands">

<META name="keywords" content="macros, commands, user">

</HEAD>

<BODY BGCOLOR="#DDDDDD" TEXT="#000000">
<a name="top">
<table>
<td width=100%><td>
<IMG SRC="/doc/gifs/LIGO.gif" ALIGN=right ALT="LIGO.gif">
</table>

<h3> The <i>putData</i> User Commands (Meta Macros) </h3>
<b>All user commands have the form:</b>
<p>
<tt><font color="red">
<b>ldasJob</b> { -name {} -password {} -email {} } { <b>userCmd</b> -opt1 {} ... }
</tt></font>
<p>
Which is in the format of a <a href=http://www.tcl.tk/software/tcltk/><b>Tcl</b></a> command, <b>ldasJob</b>, with two required
arguments:
<ol>
<li>
A Tcl list of <b>user information</b> consisting of username,
password, and e-mail address.  All fields must be filled or
the command will be rejected.<br>
Client software which would like to receive responses from the
LDAS system on a port instead of through email can provide a
<b>hostname:port</b> combination as the email argument.  A
further feature of this method is that the hostname can be replaced
with the magic key <b>!host!</b>, and the LDAS system will use
the IP address it finds by doing a peername lookup on the
connected socket.
<li>
A <b>user command</b> in the form of a Tcl list, for which there
exists a "meta" macro file which can be expanded into Tcl code
which can then be evaluated by the LDAS system.
<br>
An argument <b>must be provided fo every option field</b> for
any given command or the command will be rejected.<br>
Some option fields will accept a "null" argument consisting of
a matching pair of braces <b>"{}"</b> with no interposed space.
<br>
Meta macros consist of a prototype declaration of the arguments
for the given user command, and a template describing the calling
order of API specific blocks of Tcl code which are concatenated
into a larger block comprising the complete request, which can
then be distributed by the assistant manager for interpretation
by the low level API's.
<br>
These API specific blocks are maintained as API specific macro
files consisting of immediately interpretable Tcl code.
</ol>
The current putData command is used to insert meta data
into the LDAS database:
<ul>
<a href="#putmetadata"><li><b><i>putMetaData</i></b></a>
</ul>
<!-- bottom of page pointer section --> 
<center>
<h2>
<a href="#putMetadata">putMetaData</a>
<IMG SRC="/doc/gifs/arrow_right.gif" ALT="arrow_right.gif">
</h2>
</center>
<!-- Here we put the stuff which will become the linked pages --> 
<hr>
<ul>
<li>
<a name="putmetadata">
<b><i>putMetaData</i></b>
<p>
Updates the database with ilwd meta data (insertion of new data).
<p>
Calling convention (all on a single line):
<p>
<b>ldasJob</b> &nbsp;
<b>{</b>
-name &nbsp; <i>"username"</i> &nbsp;
-password &nbsp; <i>"********"</i> &nbsp; 
-email &nbsp; <i>"user@site.domain"</i><b>}</b> &nbsp; 
<b>{<i>putMetaData</i></b> &nbsp; 
<a href=#returnprotocol>-returnprotocol</a> &nbsp;
   <font color="red"> <i>URL</i></font> &nbsp; 
<a href=#ingestdata>-ingestdata</a> &nbsp;
   <font color="red"> <i>URL</i></font> &nbsp; 
<a href=#database>-database</a> &nbsp;
   <font color="red"> <i>dsname</i></font> &nbsp;
<a href=#metadataapi>-metadataapi</a> &nbsp;
   <font color="red"> <i>api</i></font> &nbsp;
<a href=#ligolwquery>-ligolwquery</a> &nbsp;
   <font color="red"> <i>query</i></font> &nbsp;
<a href=#subject>-subject</a>	&nbsp;
   <font color="red"> <i>string</i></font> &nbsp;
<b>}</b>
<p>
<font color="green">Option Descriptions:</font>
<ul>
<p>
<a name=returnprotocol>
<b>-returnprotocol:</b> &nbsp; &nbsp; 
                   <tt>
                   http ftp file port
                   </tt>
<p>
<font color=red>
Optional: <i>only needed when requesting ilwd to be written to file instead
of sending off to an api for processing.</i>
</font><br>
<ul>
<tt>
The returnprotocol specifies the destination that
the result of the command should be delivered to.
The argument to the <b>-returnprotocol</b> option conforms
to the usual browser conventions for URL's for determining
the location of the results of the user request.<br>
The <b>http</b>, <b>ftp</b>, and <b>file</b> options
cause a URL pointer to the location of the results to be
returned by e-mail.<br>
The possible formats of the argument are:
<p>
<li>http://host:port/dir/...<p> 
<li>ftp://host:port/dir/...<p>
<li>file:/path/... (note, only one "/")<p>
<li>port:hostname:portnumber<p>
<p><font color="red">
NOTE: Embedded spaces in the argument to the -returnprotocol
option will cause the request to fail.</font>
</tt>
</ul>
<p>
<a name=ingestdata>
<b>-ingestdata:</b> &nbsp; &nbsp; <tt>file ftp port <i>string</i></tt>
<p>
<ul>
<tt>
The argument of the <b>-ingestdata</b> option URL format
is of the same format
as that of <b>-returnprotocol</b>. The URL specifies the source of
of the data to be ingested, usually in xml format.  A file
extension of ".xml" is required to identify the file type.
Type ilwd is also acceptable, with extension ".ilwd".

<p>
<li>http://host:port/dir/filename.xml<p> 
<li>ftp://host:port/dir/filename.xml<p>
<li>file:/path/dir/filename.xml (note, only one "/")<p>
<li>port:hostname:portnumber<p>
<p>
Embedded spaces in the argument to the -ingestdata
option will cause the request to fail.
</tt>
<p>
Ingestdata format guidelines:<p>
<font size=-1>
<ul>
<li><a href="/doc/db2/doc/html/xmlformat.html">Format of xml for data insertion</a><p></li>
<li><a href="/doc/db2/doc/html/ilwdformat.html">Format of ilwd for data insertion</a><p></li>
</ul>
<p>
<a href="/doc/db2/doc/html/tables.html">ilwd and xml examples of each table data</a>
</font>
</ul>
<p>
<a name=database>
<b>-database:</b> &nbsp; &nbsp; <tt>dsname<i>string</i></tt>
<p>
<ul>
<tt>
The argument of -database option is a valid database dataset name for
the site that the command applies e.g. <i>dev_1</i> and <i>dev_test</i> are
dataset names for site <i>ldas-dev</i>, <i>lho_1</i> and <i>lho_test</i> are
dataset names for site <i>ldas-wa</i> etc. For dsnames of sites,
please visit the LDAS database link on each ldas site web page.
If this option is not specified, insertion is done from the default database.
</tt>
</ul>
<p>
<a name=metadataapi>
<b>-metadataapi:</b> &nbsp; &nbsp; <tt>api<i>string</i></tt>
<p>
<ul>
<tt>
The argument of -metadataapi option is a valid LDAS api
to send the ilwd object from the LIGO_LW URL. Defaults to
metadataAPI. If -returnprotocol is used, this should be set
to empty list, i.e. -metadataapi {}. 
<font color=red>
Default: <i>metadata</i>
</font><br>
</tt>
</ul>
<p>
<a name=ligolwquery>
<b>-ligolwquery:</b> &nbsp; &nbsp; <tt>query<i>string</i></tt>
<p>
<ul>
<tt>
The argument of -ligolwquery option is a valid query { element position } 
for ligolwAPI to extract ilwd elements from the xml specified by the -ingestdata
option. If this option is not specified, the default is full in which
case the entire ilwd is extracted.
<font color=red>
Default: <i>full</i>
</font><br>
</tt>
</ul>
<p>
<a name=subject>
<b>-subject:</b>&nbsp;&nbsp;<tt>{subject for the return e-mail}</tt>
<p>
<ul>
<tt>
String to be used as the subject for the e-mail returned by the
system on completion of the job.
<font color=red>
Default: <i>"Data inserted ok."</i>
</font><br>
</tt>
</ul>
<p><font color="green">An example of putMetaData command:</font>
<p>
for LDAS registered user <i>foo</i> to insert xml data from -ingestdata
option. 
file <i>/ldas_outgoing/data/triggers.xml"</i> into the database and have 
the result of the insertion reported by email, submit:</p>
<b>ldasJob</b> &nbsp;
<b>{</b>
-name &nbsp; <i>"foo"</i> &nbsp;
-password &nbsp; <i>"********"</i> &nbsp; 
-email &nbsp; <i>"foo@foobar.edu"</i><b>}</b> &nbsp; 
<b>{<i>putMetaData</i></b> &nbsp; 
-ingestdata        &nbsp; <font color="red"> <i>"file:/ldas_outgoing/data/triggers.xml"</i></font>
<b>}</b>
<p>
for LDAS registered user <i>foo</i> to insert xml data via  
ftp site <i>ftp://ldas.ligo-wa.caltech.edu/pub/incoming/triggers.xml</i> into the database and have 
the result of the insertion reported by email, submit:</p>
<b>ldasJob</b><b>{</b>
-name &nbsp; <i>"foo"</i> &nbsp;
-password &nbsp; <i>"********"</i> &nbsp; 
-email &nbsp; <i>"foo@foobar.edu"</i><b>}</b> &nbsp; 
<b>{<i>putMetaData</i></b> &nbsp; 
-ingestdata <font color="red"><i>"ftp://ldas.ligo-wa.caltech.edu/pub/incoming/triggers.xml"</i></font> 
<b>}</b>
<p>
for LDAS registered user <i>foo</i> to insert xml data via 
url <i>http://www.ligo-wa.caltech.edu/~foo/toldas"</i> into the database and have 
the result of the insertion reported by email, submit:</p>
<b>ldasJob</b> &nbsp;
<b>{</b>
-name &nbsp; <i>"foo"</i> &nbsp;
-password &nbsp; <i>"********"</i> &nbsp; 
-email &nbsp; <i>"foo@foobar.edu"</i><b>}</b> &nbsp; 
<b>{<i>putMetaData</i></b> &nbsp; 
-ingestdata&nbsp; <font color="red"> <i>"http://www.ligo.caltech.edu/~foo/toldas/triggers.xml"</i></font>
<b>}</b>
<p>
for LDAS registered user <i>foo</i> to insert xml data from 
file <i>/ldas_outgoing/data/triggers.xml"</i> into database <i>cit_1</i> instead of the default database, and have 
the result of the insertion reported by email, submit:</p>
<b>ldasJob</b> &nbsp;
<b>{</b>
-name &nbsp; <i>"foo"</i> &nbsp;
-password &nbsp; <i>"********"</i> &nbsp; 
-email &nbsp; <i>"foo@foobar.edu"</i><b>}</b> &nbsp; 
<b>{<i>putMetaData</i></b> &nbsp; 
-ingestdata        &nbsp; <font color="red"> <i>"file:/ldas_outgoing/data/triggers.xml"</i></font>
-database		  &nbsp; <font color="red"> <i>cit_1</i></font>
<b>}</b>
<p>
<p>
for LDAS registered user <i>foo</i> to insert ilwd data (testing purposes only) via  
file <i>file:/ldas_outgoing/test/gds_triggers10.ilwd</i> into the database and have 
the result of the insertion reported by email, submit:</p>
<b>ldasJob</b><b>{</b>
-name &nbsp; <i>"foo"</i> &nbsp;
-password &nbsp; <i>"********"</i> &nbsp; 
-email &nbsp; <i>"foo@foobar.edu"</i><b>}</b> &nbsp; 
<b>{<i>putMetaData</i></b> &nbsp; 
-ingestdata <font color="red"><i>"file:/ldas_outgoing/test/gds_triggers10.ilwd"</i></font> 
<b>}</b>
</ul></ul>
<!-- bottom of page pointer section -->  
<center>
<h2>
<IMG SRC="/doc/gifs/arrow_up.gif" ALT="arrow_up.gif">
<a href="#top">Back to Top</a>
<IMG SRC="/doc/gifs/arrow_up.gif" ALT="arrow_up.gif">
</h2>
</center>
<!-- End of putMetaData --> 

</ul>
</BODY>

<!-- VI POWERED! -->

</HTML>
